3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .dotest working files, use the command
18 git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used. You must be in the top
22 directory of your project to start (or continue) a rebase.
24 Example: git-rebase master~1 topic
26 A---B---C topic A'\''--B'\''--C'\'' topic
28 D---E---F---G master D---E---F---G master
33 set_reflog_action rebase
38 When you have resolved this problem run \"git rebase --continue\".
39 If you would prefer to skip this patch, instead run \"git rebase --skip\".
40 To restore the original branch and stop rebasing run \"git rebase --abort\".
45 dotest=$GIT_DIR/.dotest-merge
51 test -n "$prev_head" || die "prev_head must be defined"
52 test -d "$dotest" || die "$dotest directory does not exist"
54 unmerged=$(git ls-files -u)
55 if test -n "$unmerged"
57 echo "You still have unmerged paths in your index"
58 echo "did you forget to use git add?"
62 if ! git diff-index --quiet HEAD
64 if ! git-commit -C "`cat $dotest/current`"
66 echo "Commit failed, please do not call \"git commit\""
67 echo "directly, but instead do one of the following: "
70 printf "Committed: %0${prec}d" $msgnum
72 printf "Already applied: %0${prec}d" $msgnum
74 echo ' '`git rev-list --pretty=oneline -1 HEAD | \
75 sed 's/^[a-f0-9]\+ //'`
77 prev_head=`git rev-parse HEAD^0`
78 # save the resulting commit so we can read-tree on it later
79 echo "$prev_head" > "$dotest/prev_head"
81 # onto the next patch:
82 msgnum=$(($msgnum + 1))
83 echo "$msgnum" >"$dotest/msgnum"
87 cmt="$(cat $dotest/cmt.$1)"
88 echo "$cmt" > "$dotest/current"
89 hd=$(git rev-parse --verify HEAD)
90 cmt_name=$(git symbolic-ref HEAD)
91 msgnum=$(cat $dotest/msgnum)
92 end=$(cat $dotest/end)
93 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
94 eval GITHEAD_$hd='"$(cat $dotest/onto_name)"'
95 export GITHEAD_$cmt GITHEAD_$hd
96 git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
100 unset GITHEAD_$cmt GITHEAD_$hd
108 echo "Strategy: $rv $strategy failed, try another" 1>&2
112 die "Unknown exit code ($rv) from command:" \
113 "git-merge-$strategy $cmt^ -- HEAD $cmt"
124 test -f "$dotest"/interactive ||
125 while case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
131 is_interactive "$@" && exec git-rebase--interactive "$@"
133 while case "$#" in 0) break ;; esac
137 git diff-files --quiet || {
138 echo "You must edit all merge conflicts and then"
139 echo "mark them as resolved using git add"
144 prev_head="`cat $dotest/prev_head`"
145 end="`cat $dotest/end`"
146 msgnum="`cat $dotest/msgnum`"
147 onto="`cat $dotest/onto`"
149 while test "$msgnum" -le "$end"
157 git am --resolved --3way --resolvemsg="$RESOLVEMSG"
164 prev_head="`cat $dotest/prev_head`"
165 end="`cat $dotest/end`"
166 msgnum="`cat $dotest/msgnum`"
167 msgnum=$(($msgnum + 1))
168 onto="`cat $dotest/onto`"
169 while test "$msgnum" -le "$end"
177 git am -3 --skip --resolvemsg="$RESOLVEMSG"
189 die "No rebase in progress?"
191 git reset --hard ORIG_HEAD
195 test 2 -le "$#" || usage
199 -M|-m|--m|--me|--mer|--merg|--merge)
202 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
203 --strateg=*|--strategy=*|\
204 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
207 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
233 # Make sure we do not have .dotest
234 if test -z "$do_merge"
241 It seems that I cannot create a .dotest directory, and I wonder if you
242 are in the middle of patch application or another rebase. If that is not
243 the case, please rm -fr .dotest and run me again. I am stopping in case
244 you still have something valuable there.'
250 die "previous dotest directory $dotest still exists." \
251 'try git-rebase < --continue | --abort >'
255 # The tree must be really really clean.
256 git update-index --refresh || exit
257 diff=$(git diff-index --cached --name-status -r HEAD)
259 ?*) echo "cannot rebase: your index is not up-to-date"
265 # The upstream head must be given. Make sure it is valid.
267 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
268 die "invalid upstream $upstream_name"
270 # Make sure the branch to rebase onto is valid.
271 onto_name=${newbase-"$upstream_name"}
272 onto=$(git rev-parse --verify "${onto_name}^0") || exit
274 # If a hook exists, give it a chance to interrupt
275 if test -x "$GIT_DIR/hooks/pre-rebase"
277 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
278 echo >&2 "The pre-rebase hook refused to rebase."
283 # If the branch to rebase is given, first switch to it.
287 git-checkout "$2" || usage
290 if branch_name=`git symbolic-ref -q HEAD`
292 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
294 branch_name=HEAD ;# detached
298 branch=$(git rev-parse --verify "${branch_name}^0") || exit
300 # Now we are rebasing commits $upstream..$branch on top of $onto
302 # Check if we are already based on $onto with linear history,
303 # but this should be done only when upstream and onto are the same.
304 mb=$(git merge-base "$onto" "$branch")
305 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
307 ! git rev-list --parents "$onto".."$branch" | grep " .* " > /dev/null
309 echo >&2 "Current branch $branch_name is up to date."
313 if test -n "$verbose"
315 echo "Changes from $mb to $onto:"
316 # We want color (if set), but no pager
317 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
320 # Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
321 echo "First, rewinding head to replay your work on top of it..."
322 git-reset --hard "$onto"
324 # If the $onto is a proper descendant of the tip of the branch, then
325 # we just fast forwarded.
326 if test "$mb" = "$branch"
328 echo >&2 "Fast-forwarded $branch_name to $onto_name."
332 if test -z "$do_merge"
334 git format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
335 git am $git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG"
339 # start doing a rebase with git-merge
340 # this is rename-aware if the recursive (default) strategy is used
343 echo "$onto" > "$dotest/onto"
344 echo "$onto_name" > "$dotest/onto_name"
345 prev_head=`git rev-parse HEAD^0`
346 echo "$prev_head" > "$dotest/prev_head"
349 for cmt in `git rev-list --reverse --no-merges "$upstream"..ORIG_HEAD`
351 msgnum=$(($msgnum + 1))
352 echo "$cmt" > "$dotest/cmt.$msgnum"
355 echo 1 >"$dotest/msgnum"
356 echo $msgnum >"$dotest/end"
361 while test "$msgnum" -le "$end"